about summary refs log tree commit diff
path: root/scripts/nix-pull-prebuilts
diff options
context:
space:
mode:
authorEelco Dolstra <e.dolstra@tudelft.nl>2003-05-25T22·42+0000
committerEelco Dolstra <e.dolstra@tudelft.nl>2003-05-25T22·42+0000
commit7dd91d3779b4f806ac0085e0ccc60416d81c1148 (patch)
treee4c5f7e8d8978df671050fae0c25639cca79e251 /scripts/nix-pull-prebuilts
parent0ef4b6d0f8dcaec093e3db366b6dfb6ba47f73a6 (diff)
* Prebuilt package sharing. We allow transparent binary deployment by
  sharing package directories (i.e., the result of building a Nix
  descriptor).

  `nix-pull-prebuilts' obtains a list of all known prebuilts by
  consulting the paths and URLs specified in
  $prefix/etc/nix/prebuilts.conf.  The mappings ($pkghash,
  $prebuilthash) and ($prebuilthash, $location) are registered with
  Nix so that it can use the prebuilt with hash $prebuilthash when
  installing a package with hash $pkghash by downloading and unpacking
  $location.

  `nix-push-prebuilts' creates prebuilts for all packages for which no
  prebuilt is known to exist.  It can then optionally upload these
  to the network through rsync.

  `nix-[pull|push]-prebuilts' just provide a policy.  Nix provides the
  mechanism through the `nix [export|regprebuilt|regurl]' commands.


Diffstat (limited to 'scripts/nix-pull-prebuilts')
-rwxr-xr-xscripts/nix-pull-prebuilts69
1 files changed, 69 insertions, 0 deletions
diff --git a/scripts/nix-pull-prebuilts b/scripts/nix-pull-prebuilts
new file mode 100755
index 000000000000..91bbf8082b35
--- /dev/null
+++ b/scripts/nix-pull-prebuilts
@@ -0,0 +1,69 @@
+#! /usr/bin/perl -w
+
+my $prefix = $ENV{"NIX"} || "/nix"; # !!! use prefix
+my $etcdir = "$prefix/etc/nix";
+my $knowns = "$prefix/var/nix/known-prebuilts";
+my $tmpfile = "$prefix/var/nix/prebuilts.tmp";
+
+my $conffile = "$etcdir/prebuilts.conf";
+
+sub register {
+    my $fn = shift;
+    return unless $fn =~ /([^\/]*)-([0-9a-z]{32})-([0-9a-z]{32})\.tar\.bz2/;
+    my $id = $1;
+    my $pkghash = $2;
+    my $prebuilthash = $3;
+    print "$pkghash => $prebuilthash ($id)\n";
+    system "nix regprebuilt $pkghash $prebuilthash";
+    if ($?) { die "`nix regprebuilt' failed"; }
+    print KNOWNS "$pkghash\n";
+}
+
+open KNOWNS, ">$knowns";
+
+open CONFFILE, "<$conffile";
+
+while (<CONFFILE>) {
+    chomp;
+    if (/^\s*(\S+)\s*(\#.*)?$/) {
+        my $url = $1;
+
+        print "obtaining prebuilt list from $url...\n";
+
+        if ($url =~ /^\//) {
+
+            # It's a local path.
+
+            foreach my $fn (glob "$url/*") {
+                register $fn;
+            }
+
+        } else {
+
+            # It's a URL.
+
+            system "wget '$url' -O '$tmpfile' 2> /dev/null"; # !!! escape
+            if ($?) { die "`wget' failed"; }
+
+            open INDEX, "<$tmpfile";
+
+            while (<INDEX>) {
+                # Get all links to prebuilts, that is, file names of the
+                # form foo-HASH-HASH.tar.bz2.
+                next unless (/HREF=\"([^\"]*)\"/);
+                my $fn = $1;
+                next if $fn =~ /\.\./;
+                next if $fn =~ /\//;
+                register $fn;
+            }
+
+            close INDEX;
+
+            unlink $tmpfile;
+        }
+    }
+}
+
+close CONFFILE;
+
+close KNOWNS;